[<prev] [next>] [<thread-prev] [day] [month] [year] [list]
Message-ID: <62c02ce25e086feb7a299e441633823994e87073.camel@intel.com>
Date: Fri, 31 Jan 2025 15:49:38 +0000
From: "Falcon, Thomas" <thomas.falcon@...el.com>
To: "james.clark@...aro.org" <james.clark@...aro.org>,
"alexander.shishkin@...ux.intel.com" <alexander.shishkin@...ux.intel.com>,
"linux-perf-users@...r.kernel.org" <linux-perf-users@...r.kernel.org>,
"linux-kernel@...r.kernel.org" <linux-kernel@...r.kernel.org>,
"peterz@...radead.org" <peterz@...radead.org>, "acme@...nel.org"
<acme@...nel.org>, "mingo@...hat.com" <mingo@...hat.com>,
"mark.rutland@....com" <mark.rutland@....com>, "Hunter, Adrian"
<adrian.hunter@...el.com>, "namhyung@...nel.org" <namhyung@...nel.org>,
"jolsa@...nel.org" <jolsa@...nel.org>, "kan.liang@...ux.intel.com"
<kan.liang@...ux.intel.com>, "irogers@...gle.com" <irogers@...gle.com>,
"Wang, Weilin" <weilin.wang@...el.com>
Subject: Re: [PATCH v3] perf test shell tpebs: Extra verbosity and hypervisor
skip
On Thu, 2025-01-30 at 09:01 -0800, Ian Rogers wrote:
> When not running as root and with higher perf event paranoia values
> the perf record forked by TPEBS can fail to attach to the process.
> Skip
> the test in these scenarios.
>
> Intel TPEBS test skips on non-Intel CPUs. On Intel CPUs under a
> hypervisor the cache-misses event may not be present or precise. Skip
> the test under this condition.
>
> Refactor the output code to be placed in a file so that on a signal
> the file can be dumped. This was necessary to catch the issue above
> as
> the failing perf record command would fail without output.
>
> Signed-off-by: Ian Rogers <irogers@...gle.com>
> ---
> v3: Add/squash missed patches pointed out by "Falcon, Thomas"
> <thomas.falcon@...el.com>
> v2: Fix lost :R and use :p with record as it is ignored by perf stat.
> ---
Works for me on an i9-12900 and Core Ultra 9 275HX .
Tested-by: Thomas Falcon <thomas.falcon@...el.com>
Thanks
> .../perf/tests/shell/test_stat_intel_tpebs.sh | 89 ++++++++++++++++-
> --
> 1 file changed, 76 insertions(+), 13 deletions(-)
>
> diff --git a/tools/perf/tests/shell/test_stat_intel_tpebs.sh
> b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
> index f95fc64bf0a7..a330ecdb7ba5 100755
> --- a/tools/perf/tests/shell/test_stat_intel_tpebs.sh
> +++ b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
> @@ -3,20 +3,83 @@
> # SPDX-License-Identifier: GPL-2.0
>
> set -e
> -grep -q GenuineIntel /proc/cpuinfo || { echo Skipping non-Intel;
> exit 2; }
>
> -# Use this event for testing because it should exist in all
> platforms
> -event=cache-misses:R
> +ParanoidAndNotRoot() {
> + [ "$(id -u)" != 0 ] && [ "$(cat
> /proc/sys/kernel/perf_event_paranoid)" -gt $1 ]
> +}
>
> -# Hybrid platforms output like "cpu_atom/cache-misses/R", rather
> than as above
> -alt_name=/cache-misses/R
> +if ! grep -q GenuineIntel /proc/cpuinfo
> +then
> + echo "Skipping non-Intel"
> + exit 2
> +fi
>
> -# Without this cmd option, default value or zero is returned
> -#echo "Testing without --record-tpebs"
> -#result=$(perf stat -e "$event" true 2>&1)
> -#[[ "$result" =~ $event || "$result" =~ $alt_name ]] || exit 1
> +if ParanoidAndNotRoot 0
> +then
> + echo "Skipping paranoid >0 and not root"
> + exit 2
> +fi
>
> -# In platforms that do not support TPEBS, it should execute without
> error.
> -echo "Testing with --record-tpebs"
> -result=$(perf stat -e "$event" --record-tpebs -a sleep 0.01 2>&1)
> -[[ "$result" =~ "perf record" && "$result" =~ $event || "$result" =~
> $alt_name ]] || exit 1
> +stat_output=$(mktemp /tmp/__perf_stat_tpebs_output.XXXXX)
> +
> +cleanup() {
> + rm -rf "${stat_output}"
> + trap - EXIT TERM INT
> +}
> +
> +trap_cleanup() {
> + echo "Unexpected signal in ${FUNCNAME[1]}"
> + cat "${stat_output}"
> + cleanup
> + exit 1
> +}
> +trap trap_cleanup EXIT TERM INT
> +
> +# Event to be used in tests
> +event=cache-misses
> +
> +if ! perf record -e "${event}:p" -a -o /dev/null sleep 0.01 >
> "${stat_output}" 2>&1
> +then
> + echo "Missing ${event} support"
> + cleanup
> + exit 2
> +fi
> +
> +test_with_record_tpebs() {
> + echo "Testing with --record-tpebs"
> + if ! perf stat -e "${event}:R" --record-tpebs -a sleep 0.01 >
> "${stat_output}" 2>&1
> + then
> + echo "Testing with --record-tpebs [Failed perf stat]"
> + cat "${stat_output}"
> + exit 1
> + fi
> +
> + # Expected output:
> + # $ perf stat --record-tpebs -e cache-misses:R -a sleep 0.01
> + # Events enabled
> + # [ perf record: Woken up 2 times to write data ]
> + # [ perf record: Captured and wrote 0.056 MB - ]
> + #
> + # Performance counter stats for 'system wide':
> + #
> + # 0 cache-misses:R
> + #
> + # 0.013963299 seconds time elapsed
> + if ! grep "perf record" "${stat_output}"
> + then
> + echo "Testing with --record-tpebs [Failed missing perf record]"
> + cat "${stat_output}"
> + exit 1
> + fi
> + if ! grep "${event}:R" "${stat_output}" && ! grep "/${event}/R"
> "${stat_output}"
> + then
> + echo "Testing with --record-tpebs [Failed missing event name]"
> + cat "${stat_output}"
> + exit 1
> + fi
> + echo "Testing with --record-tpebs [Success]"
> +}
> +
> +test_with_record_tpebs
> +cleanup
> +exit 0
Powered by blists - more mailing lists